<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;11374400">
	<META NAME="CHANGED" CONTENT="20070710;12224700">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Brute Force Parser –
Unrestricted Grammar </B></FONT>
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Run Brute Force Parser on Unrestricted Grammar</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition 
</H2>
<P STYLE="margin-bottom: 0in">An unrestricted grammar is similar to a
context-free grammar (CFG), except that the left side of a production
may contain any nonempty string of terminals and variables, rather
than just a single variable.</P>
<P>In a CFG, the single variable on the left side of a production
could be expanded in a derivation step. In an unrestricted grammar,
multiple variables and/or terminals that match the left-side of a
production can be expanded by the right-side of that production. 
</P>
<P><BR><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Run Brute Force Parser on Unrestricted Grammar</H2>
<P><A NAME="language1"></A>We will begin by loading an unrestricted
grammar for the language a<SUP>n</SUP>b<SUP>n</SUP>c<SUP>n</SUP>,
n&gt;0. Load the file <A HREF="unrestrictedGrammar.jff">unrestrictedGrammar.jff</A>.
After loading the file your grammar editor should look like this : 
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/grammar_window.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in">After clicking <B>Input</B>, then <B>Brute
Force Parse</B>, you should see a window similar to this.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/bruteforceURG.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now you can input a string
and check whether it is accepted. Enter the string “aabbcc”
(a<SUP>2</SUP>b<SUP>2</SUP>c<SUP>2</SUP>) in the input text field.
Then either click <B>Start</B> or press <B>Enter key.</B></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">For the first 3 <B>Steps</B>,
Brute Force Parser runs just like it did with context-free grammar.
However, after clicking the <B>Step</B> button the fourth time, you
will notice that Brute Force Parser combines variable “B” and
terminal “b” in a blue oval and replaces them with the two nodes
b and B using the “Bb-&gt;bB” production. Your window should look
similar to this one : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=838 HEIGHT=699 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After clicking the <B>Step</B>
button several times, it becomes clearer that Brute Force Parser is
combining two adjacent variables or terminals (representing the
left-side of productions) and replacing them with the right-side of
their production. Finally, when you reach the last step, you will see
that the input string is accepted. Here is the <B>Non-inverted Tree
</B>and <B>Derivation Table</B> of the final result.<SPAN STYLE="font-weight: medium">
Note in the tree that the leaf nodes from left to right result in the
string “aabbcc” we derived.</SPAN></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=838 HEIGHT=708 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=838 HEIGHT=708 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Brute Force Parser – Unrestricted Grammar. Thanks for
reading!</B></P>
</BODY>
</HTML>